/*
 * acs712.c
 *
 *  Created on: Apr 15, 2023
 *      Author: hussamaldean
 */

#include "stm32f4xx.h"
#include "acs712.h"

uint16_t adc_data;

uint32_t current;

void acs712_init()
{
	/*Enable floating point unit:  Enable CP10 and CP11 full access*/
	SCB->CPACR |=(1<<20);
	SCB->CPACR |=(1<<21);
	SCB->CPACR |=(1<<22);
	SCB->CPACR |=(1<<23);

	RCC->AHB1ENR|=RCC_AHB1ENR_GPIOAEN; //enable gpio a clock
	GPIOA->MODER|=GPIO_MODER_MODER1;  //set the PA1 to analog mode

	RCC->APB2ENR|=RCC_APB2ENR_ADC1EN; //enable adc clock

	ADC1->CR2=0; //disable the adc

	ADC1->SQR3|=1;

	ADC1->SMPR2|= (0x07<<ADC_SMPR2_SMP1_Pos);

	ADC1->CR2|=1; //enable the adc

}

int32_t get_acs712_current()
{
	adc_data=0;
	for (int i=0;i<10;i++){
	ADC1->CR2|=ADC_CR2_SWSTART; //start adc conversion

	while(!((ADC1->SR)&ADC_SR_EOC)){;}

	adc_data+=ADC1->DR;
	}
	adc_data=adc_data/10;

	current=(18.85*adc_data)-38074;
	return current;

}
